.model small
.stack 100h		;pilha com tamanho 256 (100h)
.data			;o segmento ".data" (duh =P)

	filename	db	'00.bmp',0
	
.data?			;o famoso segmento ".bss"

	file		dw	?				;guarda a posicao do nome do arquivo na memoria (offset filenameXX)
	hand		dw	?				;guarda o handle do arquivo aberto no momento
	
	imgData		db	64000 dup(?)	;guarda a imagem de resoluo 320x200x256
	count		dw	?				;variavel de contagem multi-uso
	nimagens		dw	?				;variavel de contagem multi-uso
	pixelLimite	dw	?		;pixelUsadoParaLimitarTela

	col			db	?				;usado para iterar por todas as 256 cores da paleta

BitmapHeader struc					;o header do arquivo ".bmp", alm disso  intil,
   id			db   2 dup(?)		;a menos que voc queira obter algumas informaes da imagem
   filesize		dw   2 dup(?)
   reserved		dw   2 dup(?)
   headersize	dw   2 dup(?)
   infosize		dw   2 dup(?)
   wid			dw   2 dup(?)
   depth		dw   2 dup(?)
   biplanes		dw   ?
   bits			dw   ?
   bicomp		dw   2 dup(?)
   bisizeim		dw   2 dup(?)
   bixpels		dw   2 dup(?)
   biypels		dw   2 dup(?)
   biclrused	dw   2 dup(?)
   biclrimp		dw   2 dup(?)
BitmapHeader ends

RGBQuad struc						;uma tupla que guarda as informaes de uma das cores da paleta
   blue		db   ?					;h 256 em um arquivo ".bmp" que usa 256 cores
   green	db   ?					;no existe em bitmaps de 24 bits
   red		db   ?
   fill		db   ?
RGBQuad ends

	head	BitmapHeader ?
	rgb		RGBQuad ?

.code

openImage proc				;abre o arquivo indicado por file e carrega as suas informaes na memria

	mov ax, 03d00h			;INT 21,3D: abre o arquivo
	mov dx, file
	int 21h
	
	mov hand, ax			;salva o handle do arquivo
	
	;retira o header do arquivo bitmap
	mov ax, 03f00h			;INT 21,3F: l o arquivo
	mov bx, hand
	mov cx, 54				;quantidade de bytes a ser lida
	mov dx, offset head		;ponteira para a posio da memria do buffer
	int 21h
	
	call setPallete
	
	;retira a imagem do arquivo bitmap
	mov ax, 03f00h			;INT 21,3F: l o arquivo
	mov bx, hand
	mov cx, 64000
	mov dx, offset imgData
	int 21h
	
	ret

openImage endp

closeImage proc				;fecha o arquivo, desativando o handle

	mov ax, 03e00h
	mov dx, hand
	int 21h
	
	ret

closeImage endp

printImage proc				;printa a imagem na tela, PS.: aps uma extensiva anlise descobri que
							;isto aqui est desenhando a imagem de cabea para baixo
	mov si, offset imgData		;SI indica o primeiro pixel da imagem
	add si, 63999			;Ultimo pixel da imagem
	mov pixelLimite, si
	sub si, 319			; Pegando primeiro pixel da linha
	mov ax, 0a000h			;no da pra fazer 'mov es, 0a000h' direto, logo GAMBIARRA
	mov es, ax				;0a000h indica o comeo da memria de vdeo que est acessvel

	cld						;garante que as operaes com a memria sairo direito
	mov count, 0		;inicia o contador, 320x200=64000, mas o primeiro valor  zero
	mov di, 0				;DI indica o primeiro pixel da tela
lp:
	mov al, [si]			;pega a cor do prximo pixel
	stosb					;salva o pixel na memria ( ES:DI <= AL ), e tambm incrementa DI

	inc si

	cmp count, 63999			;se o contador chegar a zero, sai do loop

	cmp pixelLimite, si

	jne Continuacao
	sub pixelLimite, 320
	sub si, 640
	
	Continuacao:
	inc count
	jne lp
	
	ret

printImage endp

setPallete proc				;l o arquivo indicado pelo handle para obter a paleta de cores da imagem

	mov	col, 0				;inicia o contador da cor
pallete:
	mov ax, 03f00h			;INT 21,3F
	mov bx, hand
	mov cx, 4
	mov dx, offset rgb
	int 21h

	mov	dx, 03c8h			;porta usada para indicar qual cor da paleta ser setada
	mov	al, col				;a cor a ser setada
	out	dx, al

	mov	dx, 03c9h			;porta para setar em sequncia os niveis de cor RGB

	mov	al, rgb.red			;o nivel de vermelho ( 0 - 255 )
	shr al, 2
	out	dx, al

	mov	al, rgb.green		;o nivel de verde ( 0 - 255 )
	shr	al, 2
	out	dx, al

	mov	al, rgb.blue		;o nivel de azul ( 0 - 255 )
	shr	al, 2
	out	dx, al

	cmp	col, 255			;se chegar a cor nmero 255  o fim da paleta
	inc	col
	jne pallete
	
	ret

setPallete endp

waitPrint proc				;espera os perodos ativo e de retrao do monitor,
							;alm de servir de temporizador entre imagens
	mov count, 5			;incia o contador para a quatidade de repeties que se vai esperar (valor arbitrrio)
	mov dx, 03dah			;porta para se obter o estado do monitor
loop1:
	in al, dx				;l o estado do monitor no registrador AL
	test al, 8				;se o bit 8 estiver setado, sai do loop
	jnz loop1
loop2:
	in al, dx				;l o estado do monitor no registrador AL
	test al, 8				;se o bit 8 estiver setado, sai do loop
	jz loop2
	
	cmp count, 0			;repete at o contador chegar a zero
	dec count
	jne loop1

	ret

waitPrint endp

incremento proc

	
	cmp 1[filename], '9'
	je pulouCasa
	add 1[filename], 1
	
	jmp procFim
	
	pulouCasa:
		
		mov 1[filename], '0'
		add [filename], 1
	
	procFim:	
	ret
incremento endp


start:


	mov	ax, @data			;outra GAMBIARRA
	mov	ds, ax				;seta o DS para o comeco do segmento .data (juro que sem isso no funcionava)

	mov ax, 0f00h			;INT 10,F: obtm informaes de video
	int 10h					;aqui s serve para resgatar o DOS ao modo de video original (seno fica seboso quando sai do programa)
	push ax					;AL contm o modo de video atual, mando ele pra pilha
	
	mov ax, 00013h			;INT 10,0: seta o modo de video, AL = 13h => 320x200x256
	int 10h


	mov nimagens, 0
tela: 


	
	mov file, offset filename		;seta file para o arquivo desejado

	call openImage			;carrega a imagem
	call printImage			;printa a imagem
	call waitPrint			;espera os tempos necessrios
	call closeImage			;fecha a imagem

	mov ah, 06h				;INT 21,6: testa o teclado para ver se houve entrada do usurio
	mov dl, 0ffh
	int 21h
	jnz fim					;caso haja entrada, ZF ser zero
							;o ciclo se repete para cada imagem 		

	
	cmp nimagens, 36
	je tela
	call incremento
	inc nimagens
	jmp tela

fim:
	pop ax					;resgata o modo de video original da pilha
	mov ah, 0				;INT 10,0
	int 10h

	mov ax, 0c00h			;INT 21,C: limpa o buffer do teclado
	int 21h

	mov ax, 0				;INT 21,0: termina a execuo do programa
	int 21h

end start